var enableLog = true;

if (enableLog) {
    console.log('enable user_agent.js called');
}

function applyUserAgent(userAgentName, userAgentValue) {
    if (enableLog) {
        console.log("applyUserAgent called");
        console.log("userAgentName:", userAgentName);
        console.log("userAgentValue:", userAgentValue);
    }
    if (document != undefined && !document.getElementById('user_agent_changer')) {
        (function () {
            Object.defineProperty(navigator, 'userAgent', {
                value: userAgentValue,
                configurable: true, // necessary to change value more than once
            });
            Object.defineProperty(navigator, 'appVersion', {
                value: userAgentValue,
                configurable: true, // necessary to change value more than once
            });
            Object.defineProperty(navigator, 'maxTouchPoints', {
                value: 1,
                configurable: true, // necessary to change value more than once
            });

            var actualCode = '(' + function (userAgentValue) {
                'use strict';
                var navigator = window.navigator;
                var screenOrientation = window.screen.orientation;
                var modifiedNavigator;

                var modifiedScreenOrientation;

                if ('userAgent' in Navigator.prototype) {
                    // Chrome 43+ moved all properties from navigator to the prototype,
                    // so we have to modify the prototype instead of navigator.
                    modifiedNavigator = Navigator.prototype;

                } else {
                    // Chrome 42- defined the property on navigator.
                    modifiedNavigator = Object.create(navigator);
                    Object.defineProperty(window, 'navigator', {
                        value: modifiedNavigator,
                        configurable: false,
                        enumerable: false,
                        writable: false,
                    });
                }

                if ('type' in ScreenOrientation.prototype) {
                    // Chrome 43+ moved all properties from navigator to the prototype,
                    // so we have to modify the prototype instead of navigator.
                    modifiedScreenOrientation = ScreenOrientation.prototype;

                } else {
                    // Chrome 42- defined the property on navigator.
                    modifiedScreenOrientation = Object.create(screenOrientation);
                    Object.defineProperty(window.screen, 'orientation', {
                        value: modifiedScreenOrientation,
                        configurable: false,
                        enumerable: false,
                        writable: false,
                    });
                }

                Object.defineProperties(modifiedNavigator, {
                    userAgent: {
                        value: userAgentValue,
                        configurable: false,
                        enumerable: true,
                        writable: false,
                    },
                    appVersion: {
                        value: userAgentValue,
                        configurable: false,
                        enumerable: true,
                        writable: false,
                    },
                    maxTouchPoints: {
                        value: 1,
                        configurable: false,
                        enumerable: true,
                        writable: false,
                    },
                });
            } + ')("' + userAgentValue + '");';

            var s = document.createElement('script');
            s.id = 'user_agent_changer';
            s.textContent = actualCode;
            document.documentElement.appendChild(s);
            //s.remove();
        })();
    }
}

chrome.storage.local.get('is_enabled_storage', function (item) {
    console.log(item);
    if (item) {
        if (item['is_enabled_storage']) {
            var isEnabledStorage = item['is_enabled_storage'];
            if (isEnabledStorage === 'enabled') {
                chrome.storage.local.get('user_agent_name_storage', function (item) {
                    if (enableLog) {
                        console.log(item);
                    }
                    if (item) {
                        if (item['user_agent_name_storage']) {
                            var userAgentNameStorage = item['user_agent_name_storage'];
                            chrome.storage.local.get('user_agent_value_storage', function (item) {
                                if (enableLog) {
                                    console.log(item);
                                }
                                if (item) {
                                    if (item['user_agent_value_storage']) {
                                        var userAgentValueStorage = item['user_agent_value_storage'];

                                        if (enableLog) {
                                            console.log("userAgentNameStorage:", userAgentNameStorage);
                                            console.log("userAgentValueStorage:", userAgentValueStorage);
                                        }

                                        applyUserAgent(userAgentNameStorage, userAgentValueStorage);
                                    } else {
                                        // not enabled
                                        return;
                                    }
                                } else {
                                    // not enabled
                                    return;
                                }
                            });
                        } else {
                            // not enabled
                            return;
                        }
                    } else {
                        // not enabled
                        return;
                    }
                });
            }
        } else {
            // not enabled
            return;
        }
    } else {
        // not enabled
        return;
    }
});
